
/*  A Bison parser, made from ql.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	DOT	258
#define	COMMA	259
#define	TWO_OP	260
#define	ERROR	261
#define	L_PAREN	262
#define	R_PAREN	263
#define	L_LIST	264
#define	R_LIST	265
#define	L_SET	266
#define	R_SET	267
#define	L_BAG	268
#define	R_BAG	269
#define	TOK_STRING	270
#define	TOK_DATE	271
#define	TOK_FLOAT	272
#define	TOK_INTEGER	273
#define	VARIABLE	274
#define	WS_L_PAREN	275

#line 10 "ql.y"

#ifndef QL_ERROR_H
#include "ql_error.H"
#endif

#ifndef QL_ARGS_H
#include "ql_args.H"
#endif

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef VALUE_H
#include "value.H"
#endif

#ifndef QL_TERM_H
#include "ql_term.H"
#endif;

#ifndef QL_EVAL_H
#include "ql_eval.H"
#endif

extern int yylex();
extern char ql_string[];

void yyerror(char *msg)
{
  ql_parse_error(msg);
}

static QL_Bindings *bindings = 0;

extern int yyparse();

extern int sigint_seen;  // Defined in main.C

int parse()
{
  bindings = new QL_Bindings;
  ql_eval = 1;
  sigint_seen = 0;
  // QL_eval is responsible for deleting the bindings
  // and any other temporarily allocated storage.
  // The production for the end of a query is
  // responsible for re-initializing bindings.
  
  Value::pushmem(); // Set a memory arena for Value's.
  int r = yyparse();
  Value::popmem_last(); // Reclaim the last of the memory.
  return r;
}

extern int respond_with_control_A;  // defined in ql.l

#define YYSTYPE void *

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		88
#define	YYFLAG		-32768
#define	YYNTBASE	21

#define YYTRANSLATE(x) ((unsigned)(x) <= 275 ? yytranslate[x] : 44)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     7,     9,    12,    14,    18,    20,    22,
    24,    28,    30,    34,    36,    40,    45,    47,    49,    51,
    55,    60,    65,    69,    74,    79,    81,    83,    85,    89,
    91,    93,    95,    97,    99,   101,   103,   107,   109,   113,
   115,   117,   119,   122,   126,   129,   133,   136,   140,   142,
   144,   146,   148,   150,   154,   155,   157
};

static const short yyrhs[] = {    -1,
    21,    22,     0,    23,     3,     0,     3,     0,     1,     3,
     0,    25,     0,    25,     4,    23,     0,     7,     0,    20,
     0,    30,     0,    33,     5,    32,     0,     5,     0,     5,
    24,     8,     0,    27,     0,    19,    24,     8,     0,    19,
    24,    31,     8,     0,    19,     0,    26,     0,    29,     0,
    15,     7,     8,     0,    15,     7,    31,     8,     0,     5,
     7,    31,     8,     0,    15,    20,     8,     0,    15,    20,
    31,     8,     0,     5,    20,    31,     8,     0,    15,     0,
    28,     0,    32,     0,    32,     4,    31,     0,    33,     0,
    41,     0,    40,     0,    19,     0,    28,     0,    26,     0,
    35,     0,    35,     4,    34,     0,    40,     0,    24,    34,
     8,     0,    37,     0,    38,     0,    39,     0,     9,    10,
     0,     9,    34,    10,     0,    11,    12,     0,    11,    34,
    12,     0,    13,    14,     0,    13,    34,    14,     0,    15,
     0,    16,     0,    17,     0,    18,     0,    36,     0,    33,
     5,    43,     0,     0,    42,     0,    32,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    81,    82,    85,    91,    94,   101,   102,   108,   108,   110,
   111,   118,   123,   128,   131,   132,   136,   139,   142,   148,
   151,   154,   159,   160,   161,   164,   167,   169,   170,   177,
   178,   180,   181,   183,   185,   193,   194,   198,   199,   205,
   206,   207,   211,   213,   216,   218,   221,   225,   232,   233,
   234,   235,   236,   240,   250,   254,   255
};

static const char * const yytname[] = {   "$","error","$illegal.","DOT","COMMA",
"TWO_OP","ERROR","L_PAREN","R_PAREN","L_LIST","R_LIST","L_SET","R_SET","L_BAG",
"R_BAG","TOK_STRING","TOK_DATE","TOK_FLOAT","TOK_INTEGER","VARIABLE","WS_L_PAREN",
"queries","query","terms","l_paren","term","var_paren_term","bad_term","good_paren_term",
"ws_paren_term","good_term","args","arg","simple_arg","c_args","c_arg","collection",
"list","set","bag","constant","tag_assoc","empty","tag_assoc_rhs",""
};
#endif

static const short yyr1[] = {     0,
    21,    21,    22,    22,    22,    23,    23,    24,    24,    25,
    25,    25,    25,    25,    26,    26,    27,    27,    27,    28,
    28,    28,    29,    29,    29,    30,    30,    31,    31,    32,
    32,    33,    33,    33,    33,    34,    34,    35,    35,    36,
    36,    36,    37,    37,    38,    38,    39,    39,    40,    40,
    40,    40,    40,    41,    42,    43,    43
};

static const short yyr2[] = {     0,
     0,     2,     2,     1,     2,     1,     3,     1,     1,     1,
     3,     1,     3,     1,     3,     4,     1,     1,     1,     3,
     4,     4,     3,     4,     4,     1,     1,     1,     3,     1,
     1,     1,     1,     1,     1,     1,     3,     1,     3,     1,
     1,     1,     2,     3,     2,     3,     2,     3,     1,     1,
     1,     1,     1,     3,     0,     1,     1
};

static const short yydefact[] = {     1,
     0,     0,     4,    12,     0,     0,     0,    26,    50,    51,
    52,    17,     2,     0,     6,    18,    14,    27,    19,    10,
     0,    53,    40,    41,    42,    32,     5,     8,     9,     0,
     8,    43,    49,     9,     0,     0,    36,    38,    45,     0,
    47,     0,     0,     0,     0,     3,     0,     0,     0,    49,
    33,    35,    34,     0,    28,    30,    31,     0,    13,     0,
    44,     0,    46,    48,    20,     0,    23,     0,    15,     0,
     7,    11,     0,    22,     0,    55,    25,    39,    37,    21,
    24,    16,    29,    57,    56,    54,     0,     0
};

static const short yydefgoto[] = {     1,
    13,    14,    35,    15,    52,    17,    53,    19,    20,    54,
    55,    56,    36,    37,    22,    23,    24,    25,    26,    57,
    85,    86
};

static const short yypact[] = {-32768,
    24,    12,-32768,    40,   126,   138,   150,    11,-32768,-32768,
-32768,    31,-32768,    14,    10,     6,-32768,    15,-32768,-32768,
    21,-32768,-32768,-32768,-32768,-32768,-32768,    98,    98,     4,
-32768,-32768,-32768,-32768,   162,    18,    41,-32768,-32768,    32,
-32768,     5,    53,    68,    83,-32768,   113,    98,    39,    42,
    43,-32768,-32768,    57,    44,    62,-32768,    66,-32768,    67,
-32768,   162,-32768,-32768,-32768,    70,-32768,    72,-32768,    74,
-32768,-32768,    98,-32768,    98,    98,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    89,-32768
};

static const short yypgoto[] = {-32768,
-32768,    46,     1,-32768,     7,-32768,     8,-32768,-32768,   -22,
   -42,     9,    -3,-32768,-32768,-32768,-32768,-32768,    -5,-32768,
-32768,-32768
};


#define	YYLAST		182


static const short yytable[] = {    38,
    38,    38,    40,    42,    30,    72,    58,    16,    18,    21,
   -35,    59,    45,    47,    27,   -49,    46,    43,    64,   -34,
    66,    68,    70,    87,     2,    48,     3,    61,     4,    38,
    44,    60,     5,    84,     6,   -33,     7,    31,     8,     9,
    10,    11,    12,    63,    62,    73,    28,    75,    43,    31,
    34,    45,    83,    16,    18,    21,    38,    49,    79,    29,
    65,     5,    34,     6,    74,     7,    76,    50,     9,    10,
    11,    51,    49,    77,    78,    67,     5,    80,     6,    81,
     7,    82,    50,     9,    10,    11,    51,    49,    88,     0,
    69,     5,    71,     6,     0,     7,     0,    50,     9,    10,
    11,    51,    49,     0,     0,     0,     5,     0,     6,     0,
     7,     0,    50,     9,    10,    11,    51,     4,     0,     0,
     0,     5,     0,     6,     0,     7,     0,     8,     9,    10,
    11,    12,    31,     0,     5,    32,     6,     0,     7,     0,
    33,     9,    10,    11,    31,    34,     5,     0,     6,    39,
     7,     0,    33,     9,    10,    11,    31,    34,     5,     0,
     6,     0,     7,    41,    33,     9,    10,    11,    31,    34,
     5,     0,     6,     0,     7,     0,    33,     9,    10,    11,
     0,    34
};

static const short yycheck[] = {     5,
     6,     7,     6,     7,     4,    48,    29,     1,     1,     1,
     5,     8,    12,     4,     3,     5,     3,     7,    14,     5,
    43,    44,    45,     0,     1,     5,     3,    10,     5,    35,
    20,    35,     9,    76,    11,     5,    13,     7,    15,    16,
    17,    18,    19,    12,     4,     7,     7,     4,     7,     7,
    20,    51,    75,    47,    47,    47,    62,     5,    62,    20,
     8,     9,    20,    11,     8,    13,     5,    15,    16,    17,
    18,    19,     5,     8,     8,     8,     9,     8,    11,     8,
    13,     8,    15,    16,    17,    18,    19,     5,     0,    -1,
     8,     9,    47,    11,    -1,    13,    -1,    15,    16,    17,
    18,    19,     5,    -1,    -1,    -1,     9,    -1,    11,    -1,
    13,    -1,    15,    16,    17,    18,    19,     5,    -1,    -1,
    -1,     9,    -1,    11,    -1,    13,    -1,    15,    16,    17,
    18,    19,     7,    -1,     9,    10,    11,    -1,    13,    -1,
    15,    16,    17,    18,     7,    20,     9,    -1,    11,    12,
    13,    -1,    15,    16,    17,    18,     7,    20,     9,    -1,
    11,    -1,    13,    14,    15,    16,    17,    18,     7,    20,
     9,    -1,    11,    -1,    13,    -1,    15,    16,    17,    18,
    -1,    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 85 "ql.y"
{ QL_eval((QL_Term*)yyvsp[-1],bindings);
                            if (respond_with_control_A) cout << '\001' << flush;
                            delete bindings; bindings = new QL_Bindings;
                            QL_Term::gc(); QL_Args::gc();
                            Value::popmem_last(); Value::pushmem();
                            ql_eval = 1; sigint_seen = 0;;
    break;}
case 4:
#line 91 "ql.y"
{ yyerror("empty query");
                      if (respond_with_control_A) cout << '\001' << flush;
                      ql_eval = 1; sigint_seen = 0; ;
    break;}
case 5:
#line 94 "ql.y"
{ delete bindings; bindings = new QL_Bindings;
                            if (respond_with_control_A) cout << '\001' << flush;
                            QL_Term::gc(); QL_Args::gc();
                            Value::popmem_last(); Value::pushmem();
                            ql_eval = 1; sigint_seen =0; ;
    break;}
case 6:
#line 101 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 7:
#line 103 "ql.y"
{ if (yyvsp[-2]) ((QL_Term*)yyvsp[-2])->set_next((QL_Term*)yyvsp[0]);
		  yyval = yyvsp[-2];	  
                ;
    break;}
case 10:
#line 110 "ql.y"
{yyval = yyvsp[0]; ;
    break;}
case 11:
#line 112 "ql.y"
{ if (yyvsp[-2]) { 
                      ((QL_Args*)yyvsp[-2])->set_next((QL_Args*)yyvsp[0]);
                      yyval = QL_Term::create((void*)yyvsp[-1],(QL_Args *)yyvsp[-2],
                                           error_position);
                   } else yyval = 0;
                 ;
    break;}
case 12:
#line 119 "ql.y"
{ yyval = 0;
                   ql_parse_error
                     ("A binary operator cannot appear without arguments");
                 ;
    break;}
case 13:
#line 124 "ql.y"
{ yyval = 0; 
                   ql_parse_error
                     ("A binary operator cannot appear without arguments");
                 ;
    break;}
case 14:
#line 128 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 15:
#line 131 "ql.y"
{ yyval = 0; ;
    break;}
case 16:
#line 132 "ql.y"
{ yyval = 0; ;
    break;}
case 17:
#line 136 "ql.y"
{ yyval = 0;
                   ql_parse_error
                     ("A predicate name must begin with a lower-case letter"); ;
    break;}
case 18:
#line 139 "ql.y"
{ yyval = 0;
                   ql_parse_error
                     ("A predicate name must begin with a lower-case letter"); ;
    break;}
case 19:
#line 142 "ql.y"
{ yyval = 0;
                   ql_parse_error
                     ("No space allowed between predicate name and left parenthesis"); ;
    break;}
case 20:
#line 149 "ql.y"
{ yyval 
                     = QL_Term::create(yyvsp[-2],0,error_position); ;
    break;}
case 21:
#line 152 "ql.y"
{ yyval
                     = QL_Term::create((void*)yyvsp[-3],(void*)yyvsp[-1],error_position); ;
    break;}
case 22:
#line 155 "ql.y"
{ yyval
                     = QL_Term::create((void*)yyvsp[-3],(void*)yyvsp[-1],error_position); ;
    break;}
case 23:
#line 159 "ql.y"
{ yyval = 0; ;
    break;}
case 24:
#line 160 "ql.y"
{ yyval = 0; ;
    break;}
case 25:
#line 161 "ql.y"
{ yyval = 0; ;
    break;}
case 26:
#line 165 "ql.y"
{ yyval 
                     = QL_Term::create((void*)yyvsp[0],(void*)0,error_position); ;
    break;}
case 27:
#line 167 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 28:
#line 169 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 29:
#line 170 "ql.y"
{ 
                    if (yyvsp[-2] && yyvsp[0])
                       yyval = ((QL_Args*)yyvsp[-2])->set_next((QL_Args*)yyvsp[0]);
                    else yyval = 0;
                 ;
    break;}
case 30:
#line 177 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 31:
#line 178 "ql.y"
{ yyval = new QL_Args((QL_Term*)yyvsp[0]); ;
    break;}
case 32:
#line 180 "ql.y"
{ yyval = new QL_Args((Value*)yyvsp[0]); ;
    break;}
case 33:
#line 182 "ql.y"
{ yyval = (void *) new QL_Args(bindings->add((String *)yyvsp[0])); ;
    break;}
case 34:
#line 184 "ql.y"
{ yyval = new QL_Args(/*x*/(QL_Term*)yyvsp[0]); ;
    break;}
case 35:
#line 186 "ql.y"
{ yyval = 0;
                   ql_parse_error
                     ("A predicate name must begin with a lower-case letter");
                 ;
    break;}
case 36:
#line 193 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 37:
#line 195 "ql.y"
{ yyval = ((QL_Args*)yyvsp[-2])->set_next((QL_Args*)yyvsp[0]); ;
    break;}
case 38:
#line 198 "ql.y"
{ yyval = new QL_Args((Value*)yyvsp[0]); ;
    break;}
case 39:
#line 200 "ql.y"
{ /* See about deleting this production ASAP */
                   yyval = new QL_Args(V_Collection::make(Value::LIST, (QL_Args*)yyvsp[-1])); ;
    break;}
case 40:
#line 205 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 41:
#line 206 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 42:
#line 207 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 43:
#line 212 "ql.y"
{ yyval = V_Collection::make(Value::LIST); ;
    break;}
case 44:
#line 213 "ql.y"
{ yyval = V_Collection::make(Value::LIST, (QL_Args*)yyvsp[-1]); ;
    break;}
case 45:
#line 217 "ql.y"
{ yyval = V_Collection::make(Value::SET); ;
    break;}
case 46:
#line 218 "ql.y"
{ yyval = V_Collection::make(Value::SET, (QL_Args*)yyvsp[-1]); ;
    break;}
case 47:
#line 222 "ql.y"
{ yyval = 0;
                   ql_parse_error("Bags not yet supported");
                   /* $$ = new V_Collection(Value::BAG); */ ;
    break;}
case 48:
#line 226 "ql.y"
{ yyval = 0;
                   ql_parse_error("Bags not yet supported");
                   /* ((QL_Args*)$2)->to_BAG(); */
                 ;
    break;}
case 49:
#line 232 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 50:
#line 233 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 51:
#line 234 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 52:
#line 235 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 53:
#line 236 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
case 54:
#line 241 "ql.y"
{ if (yyvsp[-2]) {
                      ((QL_Args*)yyvsp[-2])->set_next((QL_Args*)yyvsp[0]);
                      yyval = QL_Term::create((void*)yyvsp[-1],(QL_Args *)yyvsp[-2],
                                           error_position);
                   } else yyval = 0;
                 ;
    break;}
case 56:
#line 254 "ql.y"
{ yyval = 0; ;
    break;}
case 57:
#line 255 "ql.y"
{ yyval = yyvsp[0]; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 257 "ql.y"

