/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef _errno_h
#include <errno.h>
#endif

extern char *sys_errlist[];
extern int sys_nerr;

char *errno_msg()
{
  if (errno < sys_nerr)  return sys_errlist[errno];
  else return "Value of errno with no string in sys_errlist";
}
