/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef MATERIAL_SET_H
#define MATERIAL_SET_H

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef VALUE_H
#include "value.H"
#endif

#ifndef LIST_H
#include "list.H"
#endif

#ifndef BUILTIN_H
#include "builtin.H"
#endif

class All_Sets_Entry;
class List_All_Sets_Entry;

BUILTIN_NEXT_EXTERN(v_set_pred_next);
BUILTIN_NEXT_EXTERN(v_set_f_pred_next);

BUILTIN_FIRST_EXTERN(v_set_bf_pred_first);
BUILTIN_FIRST_EXTERN(v_set_bb_pred_first);
BUILTIN_FIRST_EXTERN(delete_entire_value_set_pred);
BUILTIN_FIRST_EXTERN(delete_entire_temp_value_set_pred);
extern QL_Iterator_State *v_set_delete(QL_Term*);
extern QL_Iterator_State *v_set_insert(QL_Term*);

BUILTIN_FIRST_EXTERN(temp_v_set_bf_pred_first);
BUILTIN_FIRST_EXTERN(temp_v_set_bb_pred_first);
extern QL_Iterator_State *temp_v_set_delete(QL_Term*);
extern QL_Iterator_State *temp_v_set_insert(QL_Term*);

BUILTIN_FIRST_EXTERN(v_set_f_pred_first);
BUILTIN_FIRST_EXTERN(temp_v_set_f_pred_first);
BUILTIN_FIRST_EXTERN(v_set_b_pred);
BUILTIN_FIRST_EXTERN(temp_v_set_b_pred);

Listdeclare(All_Sets_Entry);

class Value_Set_Table : public List_All_Sets_Entry {};

#endif

